#include "CRM32Pro.h"

// ---Definiciones---
#define TITULO  "Prueba con Tiles" //titulo de la ventana
#define IMG_RESOURCE "imagenes.dpf" //paquete de imagenes
#define TILES_X 15
#define TILES_Y 20

CRM32Pro_CFont *font;
char text[10];
CRM32Pro_CTile *tile;
CRM32Pro_CSprite *pj;
int px=33, py=33;
int suelo[TILES_X][TILES_Y]=
  {{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 1, 1, 2, 1, 1, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 1, 1, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
  { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}};

void RenderGraphics(int n){
  int x,y;
  int Posx,Posy;
  int tx=0,ty=0;
  int tx2, ty2;
  int toca[4];
  int mala=0;
  Uint8 *keys;

  SDL_FillRect(CRM32Pro.screen,NULL,SDL_MapRGB(CRM32Pro.screen->format,0,0,0));

  for(x=0;x<4;x++){
    toca[x]=0;
  }

  keys=SDL_GetKeyState(NULL);
  Posx=px;
  Posy=py;
  if(keys[SDLK_UP]){
    pj->SelectAnim(SPRSTATE_UP);
    pj->Resume();
    py-=8;
  }
  if(keys[SDLK_DOWN]){
    pj->SelectAnim(SPRSTATE_DOWN);
    pj->Resume();
    py+=8;
  }
  if(keys[SDLK_LEFT]){
    pj->SelectAnim(SPRSTATE_LEFT);
    pj->Resume();
    px-=8;
  }
  if(keys[SDLK_RIGHT]){
    pj->SelectAnim(SPRSTATE_RIGHT);
    pj->Resume();
    px+=8;
  }
  if(!keys[SDLK_UP] && !keys[SDLK_DOWN] && !keys[SDLK_LEFT]  && !keys[SDLK_RIGHT]){
    pj->Pause();
    pj->SelectFrame(0);
  }

  tx=px/32;
  ty=py/32;
  tx2=(px+30)/32;
  ty2=(py+28)/32;

  sprintf(text,"%d %d",tx,ty);

  toca[0]=suelo[ty][tx];
  toca[1]=suelo[ty][tx2];
  toca[2]=suelo[ty2][tx];
  toca[3]=suelo[ty2][tx2];

  for(x=0;x<4;x++){
    if(toca[x]!=2){
      mala=1;
    }
  }

  if(mala==0){
    pj->SetPosition(px,py,0);
  }else{
    px=Posx;
    py=Posy;
  }

  // Dibujamos las tiles
  for(x=0;x<TILES_X;x++){
    for(y=0;y<TILES_Y;y++){
      tile->SetPosition(y*32,x*32);
      tile->Draw(NULL,suelo[x][y]);
    }
  }

  pj->Draw();

  font->PutString(CRM32Pro.screen,5,5,text);
  sprintf(text,"%d %d %d %d",toca[0],toca[1],toca[2],toca[3]);
  font->PutString(CRM32Pro.screen,5,25,text);
}

// -------------FUNCION MAIN----------------
int main( int argc, char* args[] )
{
  // ---Variables---
  Uint8 done = 0;
  SDL_Event event;            //para recoger los eventos

  // -Log system initialize-
  ILogSystem.Init("Tiles.log",LOG_FILE,LOG_NORMAL,TITULO);

  //Iniciamos CRM32Pro
  if(CRM32Pro.Init(SDL_INIT_VIDEO|SDL_INIT_TIMER) < 0){
    ILogSystem.Msg(LOG_NORMAL,"  [LOG] - Couldnt initialize CRM32Pro: %s\n",SDL_GetError());
    return 1;
  }

  //Configuracion deseada
  CRM32Pro.Config.Title = TITULO; //titulo de la ventana
  CRM32Pro.Config.VideoWidth = 640;   //establecemos la resolucion: 640 de ancho
  CRM32Pro.Config.VideoHeight = 480;  //por 480 de alto
  CRM32Pro.Config.VideoBPP = 32;      //y una profunidad de bit de 32

  //Establecemos el modo de video
  if(!CRM32Pro.SetVideoMode()){
    CRM32Pro.Quit();
    return 1;
  }

  // -Time system initialize-
  ITimeSystem->Init();
  ITimeSystem->SetRate(40,20);  // Optional: desired Rendering and Logic Frame Rate

  //Cargamos los graficos
  tile = new CRM32Pro_CTile();
  tile->Load(IMG_RESOURCE,"suelo");
  font = new CRM32Pro_CFont;
  font->Load(IMG_RESOURCE,"fuente");
  pj = new CRM32Pro_CSprite();
  pj->Load(IMG_RESOURCE,"pj");
  pj->SetPosition(32,32);
  pj->AutoRestore(0);

  CRM32Pro.SetRenderCallback(RenderGraphics);

  // Esperamos la pulsacin de una tecla para salir
  while(done == 0) {
    while ( CRM32Pro.Update(&event) ) {
      if ( event.type == SDL_KEYDOWN )
        if(event.key.keysym.sym == SDLK_ESCAPE)
          done = 1;
    }
  }

  //Liberamos las superficies
  delete tile;
  delete pj;

  //Quit CRM32Pro
  CRM32Pro.Quit();

  return 0;
}

